import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { UserGoodsInMerchant, UserGoodsInMerchantParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询用户在商家中的代金券
 */
export async function pageUserGoodsInMerchant(params: UserGoodsInMerchantParam) {
  const res = await request.get<ApiResult<PageResult<UserGoodsInMerchant>>>(
    MODULES_API_URL + '/shop/user-goods-in-merchant/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询用户在商家中的代金券列表
 */
export async function listUserGoodsInMerchant(params?: UserGoodsInMerchantParam) {
  const res = await request.get<ApiResult<UserGoodsInMerchant[]>>(
    MODULES_API_URL + '/shop/user-goods-in-merchant',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加用户在商家中的代金券
 */
export async function addUserGoodsInMerchant(data: UserGoodsInMerchant) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-goods-in-merchant',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改用户在商家中的代金券
 */
export async function updateUserGoodsInMerchant(data: UserGoodsInMerchant) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-goods-in-merchant',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除用户在商家中的代金券
 */
export async function removeUserGoodsInMerchant(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-goods-in-merchant/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除用户在商家中的代金券
 */
export async function removeBatchUserGoodsInMerchant(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-goods-in-merchant/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询用户在商家中的代金券
 */
export async function getUserGoodsInMerchant(id: number) {
  const res = await request.get<ApiResult<UserGoodsInMerchant>>(
    MODULES_API_URL + '/shop/user-goods-in-merchant/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
